libzypp: zyppng::UserInterface Class Reference

libzypp 17.38.14

zyppng::UserInterface Class Reference

`#include <zypp-core/ng/ui/userinterface.h>`

Inheritance diagram for zyppng::UserInterface:

## Public Member Functions
| ZYPP_DECL_PRIVATE_CONSTR (UserInterface)
void | sendUserRequest (const UserRequestRef &event)
SignalProxy< void(UserRequestRef event)> | sigEvent ()
Public Member Functions inherited from zyppng::Base
| Base ()
virtual | ~Base ()
WeakPtr | parent () const
void | addChild (const Base::Ptr &child)
void | removeChild (const Ptr &child)
const std::unordered_set< Ptr > & | children () const
std::thread::id | threadId () const
template<typename T>
std::vector< std::weak_ptr< T > > | findChildren () const
template<typename T>
std::shared_ptr< T > | shared_this () const
template<typename T>
std::shared_ptr< T > | shared_this ()
template<typename T>
std::weak_ptr< T > | weak_this () const
template<typename T>
std::weak_ptr< T > | weak_this ()
template<typename SenderFunc, typename ReceiverFunc>
auto | connect (SenderFunc &&sFun, typename internal::MemberFunction< ReceiverFunc >::ClassType &recv, ReceiverFunc &&rFunc)
template<typename SenderFunc, typename ReceiverFunc, typename ... Tracker>
std::enable_if_t< std::is_member_function_pointer_v< SenderFunc >, connection > | connectFunc (SenderFunc &&sFun, ReceiverFunc &&rFunc, const Tracker &...trackers)
void | setData (uint32_t quark, zypp::AutoDispose< void * > data)
void * | data (uint32_t quark)
void | clearData (uint32_t quark)

## Protected Member Functions
| UserInterface (UserInterfacePrivate &d)
Protected Member Functions inherited from zyppng::Base
| Base (BasePrivate &dd)

## Additional Inherited Members
Public Types inherited from zyppng::Base
using | Ptr = std::shared_ptr<Base>
using | WeakPtr = std::weak_ptr<Base>
Static Public Member Functions inherited from zyppng::Base
template<typename Obj, typename Functor>
static decltype(auto) | make_base_slot (Obj *o, Functor &&f)
template<typename SenderFunc, typename ReceiverFunc>
static auto | connect (typename internal::MemberFunction< SenderFunc >::ClassType &s, SenderFunc &&sFun, typename internal::MemberFunction< ReceiverFunc >::ClassType &recv, ReceiverFunc &&rFunc)
template<typename SenderFunc, typename ReceiverFunc, typename ... Tracker>
static auto | connectFunc (typename internal::MemberFunction< SenderFunc >::ClassType &s, SenderFunc &&sFun, ReceiverFunc &&rFunc, const Tracker &...trackers)
Protected Attributes inherited from zyppng::Base
std::unique_ptr< BasePrivate > | d_ptr

## Detailed Description

Generic code that allows libzypp to send messages and request directly to the user code.

Every time a new request is sent the UserInterface::sigEvent signal is emitted, which deliveres the specific request. Depending on the type of request the frontend code can return data to libzypp, for example if a user wants to trust a key, or a simple password request.

Definition at line 32 of file userinterface.h.

## Constructor & Destructor Documentation

## ◆ UserInterface()

zyppng::UserInterface::UserInterface | ( | UserInterfacePrivate & | d | ) |
| protected

Definition at line 19 of file userinterface.cc.

## Member Function Documentation

## ◆ ZYPP_DECL_PRIVATE_CONSTR()

zyppng::UserInterface::ZYPP_DECL_PRIVATE_CONSTR | ( | UserInterface |  | ) |

## ◆ sendUserRequest()

void zyppng::UserInterface::sendUserRequest | ( | const UserRequestRef & | event | ) |

Definition at line 22 of file userinterface.cc.

## ◆ sigEvent()

SignalProxy< void(UserRequestRef)> zyppng::UserInterface::sigEvent | ( |  | ) |

Definition at line 28 of file userinterface.cc.

The documentation for this class was generated from the following files:

- zypp-core/ng/ui/userinterface.h
- zypp-core/ng/ui/userinterface.cc